%{
/*
 *  Dilbert speak:
 *
 *  Inspiration taken from "The Dilbert Principle" and other Scott Adams
 *  books. Useful filter to use before submitting any documents to high
 *  ranking management :-)
 *
 *  To compile:
 *         lex dilbert.l;  cc  -o dilbert lex.yy.c -ll
 *   or    flex dilbert.l; gcc -o dilbert lex.yy.c -lfl    (for GNU-ites)
 *
 *  Empowered concept realisation facilitating implementation:
 *         Jon Thackray <jrmt@froggy.demon.co.uk>,
 *                      <jrmt@uk.gdscorp.com> February 1997
 *
 */

#include <stdio.h>
#include <string.h>
#define GDS

char buf[128];
static int sentence_end_seen = 0;
void changeCase(char *);

%}

%a 3000
%e 3000
%p 5000
%n 3000

/* Define whitespace as not alphanumeric */
WS      [^[:alnum:]]

%%
{WS}"will use"|{WS}"will handle"               changeCase(" will utilize");
{WS}"use"|{WS}"handle"                         changeCase(" utilization");
{WS}"uses"|{WS}"handles"                       changeCase(" utilizes");
{WS}"using"|{WS}"handling"                     changeCase(" utilizing");
{WS}"help"|{WS}"assist"                        changeCase(" facilitate");
{WS}"helps"|{WS}"assists"                      changeCase(" facilitates");
{WS}"helping"|{WS}"assisting"                  changeCase(" facilitating");
{WS}"look"                                     changeCase(" evaluate");
{WS}"looking"                                  changeCase(" evaluating");
{WS}"will need"|{WS}"may need"                 changeCase(" will require");
{WS}"need"                                     changeCase(" requirement");
{WS}"needs"                                    changeCase(" requires");
{WS}"needed"                                   changeCase(" required");
{WS}"do"                                       changeCase(" implement");
{WS}"does"                                     changeCase(" implements");
{WS}"doing"                                    changeCase(" implementing");
{WS}"working"                                  changeCase(" functioning");
{WS}"I can"                                    changeCase(" I am empowered to");
{WS}"You can"                                  changeCase(" You are empowered to");
{WS}"We can"                                   changeCase(" We are empowered to");
{WS}"finding"                                  changeCase(" location evaluation");
{WS}"quicker"                                  changeCase(" maximize instantaneousness");
{WS}"enable"|{WS}"manage"                      changeCase(" empower");
{WS}"enabling"|{WS}"managing"                  changeCase(" empowering");
{WS}"improve"|{WS}"control"                    changeCase(" leverage");
{WS}"improving"|{WS}"controlling"              changeCase(" leveraging");
{WS}"liase"|{WS}"work with"|{WS}"contribute"   changeCase(" leverage team dynamics");
{WS}"liasing"|{WS}"working with"               changeCase(" leveraging team dynamics");
{WS}"training"                                 changeCase(" comptetancy procurement");
{WS}"success"                                  changeCase(" empowered radical performance");
{WS}"procedure"                                changeCase(" efficiency function");
{WS}"procedures"                               changeCase(" efficiency functions");
{WS}"development"                              changeCase(" concept realisation");
{WS}"research"                                 changeCase(" visionary foresight");
{WS}"project"                                  changeCase(" technology rationalisation");
{WS}"projects"                                 changeCase(" technology rationalisations");
{WS}"team"                                     changeCase(" corporate inter-personnel unit");
{WS}"install"                                  changeCase(" seamlessly integrate");
{WS}"release"                                  changeCase(" technology deployment");
{WS}"product"|{WS}"application"                changeCase(" core technology");
{WS}"products"|{WS}"applications"              changeCase(" core technologies");
{WS}"change"|{WS}"modify"                      changeCase(" re-engineer");
{WS}"changing"|{WS}"modifing"                  changeCase(" re-engineering");
{WS}"plan"                                     changeCase(" schedule");
{WS}"good"                                     changeCase(" excellent");
{WS}"talk"                                     changeCase(" communicate");
{WS}"talks"                                    changeCase(" communicates");
{WS}"talked"                                   changeCase(" communicated");
{WS}"fixed"                                    changeCase(" re-implemented");
{WS}"focus"                                    changeCase(" strategically concentrate");
{WS}"bug"                                      changeCase(" contrived defect");
{WS}"bugs"                                     changeCase(" unresolved defects");
{WS}"design"|{WS}"idea"                        changeCase(" paradigm");
{WS}"designs"|{WS}"ideas"                      changeCase(" paradigms");
{WS}"business"                                 changeCase(" strategic business");
{WS}"documents"|{WS}"documentation"            changeCase(" core product literature");
{WS}"memo"|{WS}"memorandum"|{WS}"notes"        changeCase(" corporate communication");
{WS}"fast"                                     changeCase(" rapid");
{WS}"test"                                     changeCase(" implement customer quality performance");
{WS}"testing"                                  changeCase(" implementing customer quality performance");
{WS}"main"                                     changeCase(" core");
{WS}"internal"                                 changeCase(" core process");
{WS}"problem"                                  changeCase(" unforseen defect");
{WS}"problems"                                 changeCase(" unforseen defects");
{WS}"information"                              changeCase(" knowledge empowerment");
{WS}"layoff"                                   changeCase(" career transition plan");
{WS}"layoffs"                                  changeCase(" career transition plans");
{WS}"company"                                  changeCase(" market facing organisation");
{WS}"companies"                                changeCase(" market facing organisations");
{WS}"group"                                    changeCase(" business unit");
{WS}"groups"                                   changeCase(" business units");
{WS}"cubicle"|{WS}"cube"|{WS}"office"          changeCase(" anti-productivity pod");
{WS}"market"                                   changeCase(" improve customer focus");
{WS}"marketing"                                changeCase(" improving customer focus");
{WS}"incompatible"                             changeCase(" proprietary");
{WS}"task"|{WS}"target"|{WS}"goal"             changeCase(" objective");
{WS}"overpriced"                               changeCase(" premium");
{WS}"engineer"                                 changeCase(" quality systems personnel");
{WS}"quality"|{WS}"process"                    changeCase(" total quality initiative");
{WS}"old technology"                           changeCase(" backward compatible");
{WS}"profit"                                   changeCase(" customer maximized revenue");
{WS}"market"|{WS}"advertise"                   changeCase(" strategic initiative of product differentiation");
{WS}"communicate"                              changeCase(" clarify process");
{WS}"communicating"                            changeCase(" clarifying processes");
{WS}"colleague"|{WS}"workmate"|{WS}"employee"  changeCase(" team-player");
{WS}"personnel"|{WS}"employees"|{WS}"staff"    changeCase(" team-players");
{WS}"as soon as possible"|{WS}"ASAP"           changeCase(" at maxiumum priority");
{WS}"myself"                                   changeCase(" self-starter");
{WS}"boss"|{WS}"manager"|{WS}"head honcho"     changeCase(" pro-active leadership");
{WS}"fire"|{WS}"redundancy"                    changeCase(" rightsize");
{WS}"increase"|{WS}"expand"|{WS}"grow"         changeCase(" maximize");
{WS}"increasing"|{WS}"expanding"|{WS}"growing" changeCase(" maximizing");
". " {
    sentence_end_seen++;
    if (sentence_end_seen > 25)
    {
       switch(rand() % 7)
       {
       case 0:
             changeCase(". Remember, work smarter, not harder. "); break;
       case 1:
             changeCase(". It's a new paradigm. "); break;
       case 2:
             changeCase(". This leverages core requirement strategies. "); break;
       case 3:
             changeCase(". Re-engineering core business strategies leverages our corporate synergy. "); break;
       /* Jim Blahahaha-isms */
#ifdef GDS
       case 4:
             changeCase(". Hang on to your harness, we'll take off like a rocket. "); break;
       case 5:
             changeCase(". I'm going to make you all millionaires. "); break;
       case 6:
             changeCase(". We want outrageously happy customers. "); break;
       case 7:
             changeCase(". Are we all singing from the same song sheet? "); break;
       case 8:
             changeCase(". Let's kick the tires of this thing. "); break;
#endif
       }
       sentence_end_seen = 0;
    }
    else
    {
       printf(". ");
    }
}
%%

/* Words and phrases to add in future:
  enable full contrivances of empowerment
  individual dignity enchancement
  core competancy
  maximize propensities
  market share

Buzzwords:
  urgent reponse compile easier satisfy multimedia requirements
  evaluate quality technology systems information efficiency
  legacy accuracy literacy target procure motivation performance
  opportunity presentation priority consult radical integrated
  direction rationalize philosophy quality mission statement concept
  synergy

This one was on Cisco's web site, and is classic management speak:
  eliminate interoperability issues resulting from a multi-vendor solution.
*/

main()
{
#ifdef unix
    srand(getpid());      /* Unix specific; remove to remove randomness */
#endif
    yylex();
}

void changeCase(char *word)
{
  extern char *yytext;
  char buf[1024];

  strncpy(buf, word, 1024);

  /* leave original type and case of whitespace unchanged */
  *(buf) = *(yytext);

  if (isupper(*(yytext+1)) && islower(*(buf+1)))
      *(buf+1) = toupper(*(buf+1));

  printf(buf);
}

